# easybuild

EasyBuild is a software build and installation framework that allows you to manage software in an efficient way: (http://easybuild.readthedocs.io/en/latest/Introduction.html). This repo provides additional easyconfigs for ELIC ecosystem

## Install

```bash
rmdir /opt/easybuild/configs
git clone ssh://git@www.climate.be:3022/pbarriat/easyconfigs.git /opt/easybuild/configs
```

## Requirements

* openSUSE : 
```bash
gcc-c++ patch libopenssl-devel gperf
```

* CentOS : 
```bash 
openssl-devel libibverbs-devel autoconf automake binutils bison flex gcc gcc-c++ gettext libtool make patch pkgconfig bzip2 unzip jq-devel v8-devel postgresql-devel tcsh check-devel unixODBC*
```

* ubuntu : 
```bash
gcc g++ gfortran libibverbs-dev
```

## Getting started

Check if you have the lastest easybuild version:

```bash
sudo pip install --upgrade pip
```

Then call `screen` and :

```bash
eb_2018b netCDF-Fortran-4.4.4-foss-2018b.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,Autoconf,GCCcore,Automake,ncurses,libtool,pkg-config,Szip,cURL,Autotools,CMake,Doxygen,numactl,xorg-macros,libpciaccess,gettext,XZ,libxml2,hwloc,FFTW -r

eb_2018b netCDF-C++4-4.3.0-foss-2018b.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,Autoconf,GCCcore,Automake,ncurses,libtool,pkg-config,Szip,cURL,Autotools,CMake,Doxygen,numactl,xorg-macros,libpciaccess,gettext,XZ,libxml2,hwloc,FFTW

eb_2018b Python-2.7.15-foss-2018b.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,Autoconf,GCCcore,Automake,ncurses,libtool,pkg-config,Szip,cURL,Autotools,CMake,Doxygen,numactl,xorg-macros,libpciaccess,gettext,XZ,libxml2,hwloc,FFTW,bzip2,libreadline,SQLite,libffi,GMP,Tcl -r

cd /opt/easybuild/configs/foss-2018b

eb_2018b ./R-3.5.1-foss-2018b-Python-2.7.15.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,Autoconf,GCCcore,Automake,ncurses,libtool,pkg-config,Szip,cURL,Autotools,CMake,Doxygen,numactl,xorg-macros,libpciaccess,gettext,XZ,libxml2,FFTW,hwloc,bzip2,libreadline,SQLite,libffi,GMP,Tcl,expat,libpng,gperf,pixman,freetype,util-linux,fontconfig,Python-2.7.15-GCCcore-7.3.0-bare,PCRE,LLVM,GLib,intltool,X11,cairo,libdrm,nettle,Mako,Mesa,libGLU,LibTIFF,NASM,libjpeg-turbo,Tk,PROJ,NLopt,libsndfile,ICU,JasPer,SWIG,GEOS,libgeotiff,GDAL,GSL,XML-Parser -r

eb_2018b ./ELIC-0.1-foss-2018b-Python-2.7.15.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,Autoconf,GCCcore,Automake,ncurses,libtool,pkg-config,Szip,cURL,Autotools,CMake,Doxygen,numactl,xorg-macros,libpciaccess,gettext,XZ,libxml2,hwloc,bzip2,libreadline,SQLite,libffi,GMP,Tcl,expat,libpng,gperf,pixman,freetype,util-linux,fontconfig,Python-2.7.15-GCCcore-7.3.0-bare,PCRE,LLVM,GLib,intltool,X11,cairo,libdrm,nettle,Mako,Mesa,libGLU,LibTIFF,NASM,libjpeg-turbo,Tk,PROJ,NLopt,libsndfile,ICU,JasPer,SWIG,GEOS,libgeotiff,GDAL,GSL,XML-Parser,LibUUID,libdap,ANTLR,g2lib,g2clib,ESMF,libiconv,xproto,makedepend,HDF,libmo_unpack,YAXT,GObject-Introspection,ATK,PyCairo,PyGObject,Gdk-Pixbuf,numba,FriBidi,HarfBuzz,Pango,GTK+,libglade,PyGTK,ecCodes -r

eb_2018b ./R-3.5.1-foss-2018b-Python-3.6.6.eb --hide-deps=M4,zlib,help2man,Bison,flex,binutils,Autoconf,GCCcore,Automake,ncurses,libtool,pkg-config,Szip,cURL,Autotools,CMake,Doxygen,numactl,xorg-macros,libpciaccess,gettext,XZ,libxml2,hwloc,bzip2,libreadline,SQLite,libffi,GMP,Tcl,expat,libpng,gperf,pixman,freetype,util-linux,fontconfig,PCRE,LLVM,GLib,intltool,X11,cairo,libdrm,nettle,libGLU,LibTIFF,NASM,libjpeg-turbo,Tk,PROJ,NLopt,libsndfile,ICU,JasPer,SWIG,GEOS,libgeotiff,GDAL,GSL,XML-Parser,g2lib,g2clib,ESMF,libiconv,xproto,makedepend,libmo_unpack,SWIG,ecCodes,GEOS,YAXT,Mako,Mesa,GObject-Introspection,ATK,PyCairo,PyGObject,Gdk-Pixbuf,FriBidi,HarfBuzz,Pango,GTK+,libglade,PyGTK,numba -r
```

* `eb --tmpdir=/tmp --parallel=12 Tkinter-2.7.14-foss-2017b-Python-2.7.14.eb`
* `eb --tmpdir=/tmp --parallel=12 MATLAB-UCL-2017a.eb`
* `eb --tmpdir=/tmp --parallel=12 ./protobuf-3.4.0-foss-2017b.eb`
* `eb --tmpdir=/tmp --parallel=12 Qt-4.8.7-foss-2017b.eb`
* `eb --tmpdir=/tmp --parallel=12 Qt5-5.9.3-foss-2017b.eb`

> eb --tmpdir=/tmp --parallel=12 ./NCL-6.4.0-foss-2017b.eb -r

```bash
cd /opt/easybuild/easyconfigs/intel-2016.02
```

* `eb --tmpdir=/tmp --parallel=12 iccifort-2016.2.181-GCC-4.9.3-2.25.eb -r`
* `eb --tmpdir=/tmp --parallel=12 ./icc-2016.2.181-GCC-4.9.3-2.25.eb`
* `eb --tmpdir=/tmp --parallel=12 ./ifort-2016.2.181-GCC-4.9.3-2.25.eb`
* `eb --tmpdir=/tmp --parallel=12 iccifort-2016.2.181-GCC-4.9.3-2.25.eb`
* `eb --tmpdir=/tmp --parallel=12 ./netCDF-Fortran-4.4.4-intel-2016.02-GCC-4.9.eb`

Finally, run 

```bash
cd /opt/easybuild/easyconfigs/utils
./install_modulerc_new.sh
```

## Python2 packages

Fix `/opt/modules/all/GEOS/3.6.2-foss-2017b-Python-2.7.14.lua` by adding `setenv("GEOS_DIR", root)`

```bash
pip install --upgrade pip

pip install cffi geos netcdf4 cdo geoval cartopy iris matplotlib ipython pyproj scikit-image pillow pandas xarray joblib six gdal shapely rasterio geopandas pytest boto3 salem motionless progressbar2 fiona geopandas configobj https://github.com/matplotlib/basemap/archive/v1.2.0rel.tar.gz

pip install spyder python_qt_binding python-qt Qt.py ecmwf-api-client pybufr-ecmwf PySide
```

## Python3 issue

Check if you have an issue with Python3:

```bash
module load Python/3.6.3-foss-2017b
pip
```

If yes: 

```bash
pip install -Iv pysha3==0.3
pip
vimdiff /opt/software/Python/3.6.3-foss-2017b/lib/python3.6/hashlib.py utils/hashlib.py
```

## Python3 packages

Fix `/opt/modules/all/GEOS/3.6.2-foss-2017b-Python-3.6.3.lua` by adding `setenv("GEOS_DIR", root)`

```bash
pip install --upgrade pip

pip install cffi geos netcdf4 cdo geoval cartopy matplotlib ipython pyproj scikit-image pillow pandas xarray joblib six gdal shapely rasterio geopandas pytest boto3 salem motionless progressbar2 fiona geopandas configobj https://github.com/matplotlib/basemap/archive/v1.2.0rel.tar.gz

pip install spyder python_qt_binding python-qt Qt.py ecmwf-api-client pybufr-ecmwf 
```

## R packages

Fix `/opt/modules/all/R/3.4.3-foss-2017b-X11-20171023.lua` by adding:

> if not isloaded("UDUNITS/2.2.26-foss-2017b") then
> 
>    load("UDUNITS/2.2.26-foss-2017b")
>    
>end

> if not isloaded("protobuf/3.4.0-foss-2017b") then
> 
>    load("protobuf/3.4.0-foss-2017b")
>    
>end


```bash
module purge
module load R
cd /opt/easybuild/easyconfigs/utils
Rscript ipak.R
```

## Matlab

```bash
sudo yum install liberation-fonts
```

### 2013a

```bash
rsync -av 10.90.90.50:/opt/software/MATLAB/2013a /opt/software/MATLAB
scp 10.90.90.50:/opt/modules/all/MATLAB/2013a.lua /opt/modules/all/MATLAB
```

